/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Register Bank Source Fragments                                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_REGBANK_DECLARATIONS
#undef GET_REGBANK_DECLARATIONS
namespace llvm {
namespace AMDGPU {
enum : unsigned {
  InvalidRegBankID = ~0u,
  AGPRRegBankID = 0,
  SGPRRegBankID = 1,
  VCCRegBankID = 2,
  VGPRRegBankID = 3,
  NumRegisterBanks,
};
} // end namespace AMDGPU
} // end namespace llvm
#endif // GET_REGBANK_DECLARATIONS

#ifdef GET_TARGET_REGBANK_CLASS
#undef GET_TARGET_REGBANK_CLASS
private:
  static const RegisterBank *RegBanks[];
  static const unsigned Sizes[];

public:
  const RegisterBank &getRegBankFromRegClass(const TargetRegisterClass &RC, LLT Ty) const override;
protected:
  AMDGPUGenRegisterBankInfo(unsigned HwMode = 0);

#endif // GET_TARGET_REGBANK_CLASS

#ifdef GET_TARGET_REGBANK_IMPL
#undef GET_TARGET_REGBANK_IMPL
namespace llvm {
namespace AMDGPU {
const uint32_t AGPRRegBankCoverageData[] = {
    // 0-31
    (1u << (AMDGPU::AGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::AV_32RegClassID - 0)) |
    0,
    // 32-63
    (1u << (AMDGPU::AGPR_32RegClassID - 32)) |
    (1u << (AMDGPU::AReg_64RegClassID - 32)) |
    (1u << (AMDGPU::AReg_64_Align2RegClassID - 32)) |
    (1u << (AMDGPU::AV_64RegClassID - 32)) |
    (1u << (AMDGPU::AV_64_Align2RegClassID - 32)) |
    0,
    // 64-95
    (1u << (AMDGPU::AReg_96RegClassID - 64)) |
    (1u << (AMDGPU::AReg_96_Align2RegClassID - 64)) |
    (1u << (AMDGPU::AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 64)) |
    (1u << (AMDGPU::AReg_128RegClassID - 64)) |
    (1u << (AMDGPU::AV_96RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_Align2RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 64)) |
    (1u << (AMDGPU::AV_128RegClassID - 64)) |
    (1u << (AMDGPU::AV_128_Align2RegClassID - 64)) |
    0,
    // 96-127
    (1u << (AMDGPU::AReg_128_Align2RegClassID - 96)) |
    (1u << (AMDGPU::AReg_128_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 96)) |
    (1u << (AMDGPU::AReg_160RegClassID - 96)) |
    (1u << (AMDGPU::AReg_160_Align2RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 96)) |
    (1u << (AMDGPU::AV_160RegClassID - 96)) |
    (1u << (AMDGPU::AV_160_Align2RegClassID - 96)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 96)) |
    0,
    // 128-159
    (1u << (AMDGPU::AReg_160_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 128)) |
    (1u << (AMDGPU::AReg_192RegClassID - 128)) |
    (1u << (AMDGPU::AReg_192_Align2RegClassID - 128)) |
    (1u << (AMDGPU::AV_192RegClassID - 128)) |
    (1u << (AMDGPU::AV_192_Align2RegClassID - 128)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 128)) |
    0,
    // 160-191
    (1u << (AMDGPU::AReg_192_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 160)) |
    (1u << (AMDGPU::AReg_224RegClassID - 160)) |
    (1u << (AMDGPU::AV_224RegClassID - 160)) |
    (1u << (AMDGPU::AV_224_Align2RegClassID - 160)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 160)) |
    0,
    // 192-223
    (1u << (AMDGPU::AReg_224_Align2RegClassID - 192)) |
    (1u << (AMDGPU::AReg_224_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 192)) |
    (1u << (AMDGPU::AReg_256RegClassID - 192)) |
    (1u << (AMDGPU::AV_256RegClassID - 192)) |
    (1u << (AMDGPU::AV_256_Align2RegClassID - 192)) |
    0,
    // 224-255
    (1u << (AMDGPU::AReg_256_Align2RegClassID - 224)) |
    (1u << (AMDGPU::AReg_256_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 224)) |
    0,
    // 256-287
    (1u << (AMDGPU::AReg_288RegClassID - 256)) |
    (1u << (AMDGPU::AReg_288_Align2RegClassID - 256)) |
    (1u << (AMDGPU::AReg_288_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 256)) |
    (1u << (AMDGPU::AV_288RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_Align2RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 256)) |
    0,
    // 288-319
    (1u << (AMDGPU::AReg_320RegClassID - 288)) |
    (1u << (AMDGPU::AReg_320_Align2RegClassID - 288)) |
    (1u << (AMDGPU::AReg_320_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 288)) |
    (1u << (AMDGPU::AV_320RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_Align2RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 288)) |
    0,
    // 320-351
    (1u << (AMDGPU::AReg_352RegClassID - 320)) |
    (1u << (AMDGPU::AV_352RegClassID - 320)) |
    (1u << (AMDGPU::AV_352_Align2RegClassID - 320)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 320)) |
    0,
    // 352-383
    (1u << (AMDGPU::AReg_352_Align2RegClassID - 352)) |
    (1u << (AMDGPU::AReg_352_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 352)) |
    0,
    // 384-415
    (1u << (AMDGPU::AReg_384RegClassID - 384)) |
    (1u << (AMDGPU::AReg_384_Align2RegClassID - 384)) |
    (1u << (AMDGPU::AReg_384_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 384)) |
    (1u << (AMDGPU::AV_384RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_Align2RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 384)) |
    0,
    // 416-447
    0,
    // 448-479
    (1u << (AMDGPU::AReg_512RegClassID - 448)) |
    (1u << (AMDGPU::AReg_512_Align2RegClassID - 448)) |
    (1u << (AMDGPU::AReg_512_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 448)) |
    (1u << (AMDGPU::AV_512RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_Align2RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 448)) |
    0,
    // 480-511
    0,
    // 512-543
    (1u << (AMDGPU::AReg_1024RegClassID - 512)) |
    (1u << (AMDGPU::AReg_1024_Align2RegClassID - 512)) |
    (1u << (AMDGPU::AReg_1024_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID - 512)) |
    0,
    // 544-575
    0,
    // 576-607
    0,
    // 608-639
    0,
    // 640-671
    0,
};
const uint32_t SGPRRegBankCoverageData[] = {
    // 0-31
    (1u << (AMDGPU::SReg_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::TTMP_LO16RegClassID - 0)) |
    (1u << (AMDGPU::M0_CLASS_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1RegClassID - 0)) |
    (1u << (AMDGPU::VS_16RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_Lo128RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_and_SReg_1RegClassID - 0)) |
    (1u << (AMDGPU::VS_32RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_with_hi16RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_Lo128RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_Lo128_with_hi16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_XEXECRegClassID - 0)) |
    (1u << (AMDGPU::VS_16_and_SReg_1_XEXECRegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_lo16_in_SGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_and_SReg_1_with_lo16_in_SGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_lo16_in_TTMP_LO16RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_and_SReg_1_with_lo16_in_TTMP_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_sub0RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_XEXEC_with_sub0RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_sub0_and_SReg_1_with_lo16_in_SGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_sub0_and_SReg_1_with_lo16_in_TTMP_LO16RegClassID - 0)) |
    0,
    // 32-63
    (1u << (AMDGPU::SReg_32RegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XEXEC_HIRegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XEXECRegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XM0_XEXECRegClassID - 32)) |
    (1u << (AMDGPU::SGPR_32RegClassID - 32)) |
    (1u << (AMDGPU::TTMP_32RegClassID - 32)) |
    (1u << (AMDGPU::M0_CLASSRegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XM0RegClassID - 32)) |
    (1u << (AMDGPU::SReg_64RegClassID - 32)) |
    (1u << (AMDGPU::SRegOrLds_32RegClassID - 32)) |
    (1u << (AMDGPU::SReg_64_XEXECRegClassID - 32)) |
    (1u << (AMDGPU::SReg_64_XEXEC_XNULLRegClassID - 32)) |
    (1u << (AMDGPU::VS_64RegClassID - 32)) |
    (1u << (AMDGPU::VS_64_with_sub0_in_VS_32_Lo128RegClassID - 32)) |
    (1u << (AMDGPU::VS_64_with_sub1_in_VS_32_Lo128RegClassID - 32)) |
    0,
    // 64-95
    (1u << (AMDGPU::SGPR_64RegClassID - 64)) |
    (1u << (AMDGPU::CCR_SGPR_64RegClassID - 64)) |
    (1u << (AMDGPU::Gfx_CCR_SGPR_64RegClassID - 64)) |
    (1u << (AMDGPU::TTMP_64RegClassID - 64)) |
    (1u << (AMDGPU::SReg_96RegClassID - 64)) |
    (1u << (AMDGPU::SReg_96_with_sub0_sub1RegClassID - 64)) |
    (1u << (AMDGPU::SGPR_96RegClassID - 64)) |
    (1u << (AMDGPU::SGPR_96_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 64)) |
    (1u << (AMDGPU::SGPR_96_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 64)) |
    (1u << (AMDGPU::TTMP_96_with_sub0_sub1RegClassID - 64)) |
    (1u << (AMDGPU::TTMP_96RegClassID - 64)) |
    (1u << (AMDGPU::SReg_96_with_sub1_sub2RegClassID - 64)) |
    0,
    // 96-127
    (1u << (AMDGPU::SReg_128RegClassID - 96)) |
    (1u << (AMDGPU::SReg_128_with_sub0_sub1_sub2RegClassID - 96)) |
    (1u << (AMDGPU::SGPR_128RegClassID - 96)) |
    (1u << (AMDGPU::SGPR_128_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 96)) |
    (1u << (AMDGPU::SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 96)) |
    (1u << (AMDGPU::SGPR_128_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 96)) |
    (1u << (AMDGPU::TTMP_128_with_sub0_sub1_sub2RegClassID - 96)) |
    (1u << (AMDGPU::TTMP_128RegClassID - 96)) |
    (1u << (AMDGPU::SReg_128_with_sub1_sub2_sub3RegClassID - 96)) |
    0,
    // 128-159
    (1u << (AMDGPU::SReg_160RegClassID - 128)) |
    (1u << (AMDGPU::SReg_160_with_sub0_sub1_sub2RegClassID - 128)) |
    (1u << (AMDGPU::SGPR_160RegClassID - 128)) |
    (1u << (AMDGPU::SGPR_160_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 128)) |
    (1u << (AMDGPU::SGPR_160_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 128)) |
    (1u << (AMDGPU::SGPR_160_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 128)) |
    (1u << (AMDGPU::TTMP_160_with_sub0_sub1_sub2RegClassID - 128)) |
    (1u << (AMDGPU::TTMP_160RegClassID - 128)) |
    (1u << (AMDGPU::SReg_160_with_sub1_sub2_sub3RegClassID - 128)) |
    (1u << (AMDGPU::SReg_160_with_sub2_sub3_sub4RegClassID - 128)) |
    0,
    // 160-191
    (1u << (AMDGPU::SReg_192RegClassID - 160)) |
    (1u << (AMDGPU::SReg_192_with_sub0_sub1_sub2RegClassID - 160)) |
    (1u << (AMDGPU::SGPR_192RegClassID - 160)) |
    (1u << (AMDGPU::SGPR_192_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 160)) |
    (1u << (AMDGPU::SGPR_192_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 160)) |
    (1u << (AMDGPU::SGPR_192_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 160)) |
    (1u << (AMDGPU::SGPR_192_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 160)) |
    (1u << (AMDGPU::SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 160)) |
    (1u << (AMDGPU::SReg_192_with_sub3_sub4_sub5RegClassID - 160)) |
    (1u << (AMDGPU::TTMP_192RegClassID - 160)) |
    (1u << (AMDGPU::SReg_192_with_sub1_sub2_sub3RegClassID - 160)) |
    (1u << (AMDGPU::SReg_192_with_sub2_sub3_sub4RegClassID - 160)) |
    0,
    // 192-223
    (1u << (AMDGPU::SReg_224RegClassID - 192)) |
    (1u << (AMDGPU::SReg_224_with_sub0_sub1_sub2RegClassID - 192)) |
    (1u << (AMDGPU::SGPR_224RegClassID - 192)) |
    (1u << (AMDGPU::SGPR_224_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 192)) |
    (1u << (AMDGPU::SGPR_224_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 192)) |
    (1u << (AMDGPU::SGPR_224_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 192)) |
    (1u << (AMDGPU::SGPR_224_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_224_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 192)) |
    (1u << (AMDGPU::SGPR_224_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 192)) |
    (1u << (AMDGPU::SReg_224_with_sub3_sub4_sub5RegClassID - 192)) |
    (1u << (AMDGPU::SReg_224_with_sub4_sub5_sub6RegClassID - 192)) |
    (1u << (AMDGPU::SReg_224_with_sub1_sub2_sub3RegClassID - 192)) |
    (1u << (AMDGPU::TTMP_224RegClassID - 192)) |
    (1u << (AMDGPU::SReg_224_with_sub2_sub3_sub4RegClassID - 192)) |
    0,
    // 224-255
    (1u << (AMDGPU::SReg_256RegClassID - 224)) |
    (1u << (AMDGPU::SReg_256_with_sub0_sub1_sub2RegClassID - 224)) |
    (1u << (AMDGPU::SGPR_256RegClassID - 224)) |
    (1u << (AMDGPU::SGPR_256_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 224)) |
    (1u << (AMDGPU::SGPR_256_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 224)) |
    (1u << (AMDGPU::SGPR_256_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 224)) |
    (1u << (AMDGPU::SGPR_256_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_256_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 224)) |
    (1u << (AMDGPU::SGPR_256_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 224)) |
    (1u << (AMDGPU::SReg_256_with_sub4_sub5_sub6RegClassID - 224)) |
    0,
    // 256-287
    (1u << (AMDGPU::SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 256)) |
    (1u << (AMDGPU::SReg_256_with_sub3_sub4_sub5RegClassID - 256)) |
    (1u << (AMDGPU::SReg_256_with_sub1_sub2_sub3RegClassID - 256)) |
    (1u << (AMDGPU::TTMP_256RegClassID - 256)) |
    (1u << (AMDGPU::SReg_256_with_sub2_sub3_sub4RegClassID - 256)) |
    0,
    // 288-319
    (1u << (AMDGPU::SReg_288RegClassID - 288)) |
    (1u << (AMDGPU::SReg_288_with_sub0_sub1_sub2RegClassID - 288)) |
    (1u << (AMDGPU::SGPR_288RegClassID - 288)) |
    (1u << (AMDGPU::SGPR_288_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 288)) |
    (1u << (AMDGPU::SGPR_288_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 288)) |
    (1u << (AMDGPU::SGPR_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 288)) |
    (1u << (AMDGPU::SGPR_288_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 288)) |
    (1u << (AMDGPU::SGPR_288_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_288_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 288)) |
    (1u << (AMDGPU::SGPR_288_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 288)) |
    (1u << (AMDGPU::SReg_288_with_sub3_sub4_sub5RegClassID - 288)) |
    (1u << (AMDGPU::TTMP_288RegClassID - 288)) |
    (1u << (AMDGPU::SReg_288_with_sub2_sub3_sub4RegClassID - 288)) |
    0,
    // 320-351
    (1u << (AMDGPU::SReg_320RegClassID - 320)) |
    (1u << (AMDGPU::SReg_320_with_sub0_sub1_sub2RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 320)) |
    (1u << (AMDGPU::SReg_320_with_sub3_sub4_sub5RegClassID - 320)) |
    (1u << (AMDGPU::TTMP_320RegClassID - 320)) |
    (1u << (AMDGPU::SReg_320_with_sub2_sub3_sub4RegClassID - 320)) |
    0,
    // 352-383
    (1u << (AMDGPU::SReg_352RegClassID - 352)) |
    (1u << (AMDGPU::SReg_352_with_sub0_sub1_sub2RegClassID - 352)) |
    (1u << (AMDGPU::SGPR_352RegClassID - 352)) |
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 352)) |
    (1u << (AMDGPU::SReg_352_with_sub8_sub9_sub10RegClassID - 352)) |
    0,
    // 384-415
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_352_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_352_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SGPR_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_352_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SGPR_352_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 384)) |
    (1u << (AMDGPU::SReg_352_with_sub3_sub4_sub5RegClassID - 384)) |
    (1u << (AMDGPU::SReg_352_with_sub2_sub3_sub4RegClassID - 384)) |
    (1u << (AMDGPU::TTMP_352RegClassID - 384)) |
    0,
    // 416-447
    (1u << (AMDGPU::SReg_384RegClassID - 416)) |
    (1u << (AMDGPU::SReg_384_with_sub0_sub1_sub2RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 416)) |
    (1u << (AMDGPU::SReg_384_with_sub3_sub4_sub5RegClassID - 416)) |
    (1u << (AMDGPU::SReg_384_with_sub8_sub9_sub10RegClassID - 416)) |
    (1u << (AMDGPU::SReg_384_with_sub2_sub3_sub4RegClassID - 416)) |
    (1u << (AMDGPU::TTMP_384RegClassID - 416)) |
    0,
    // 448-479
    0,
    // 480-511
    (1u << (AMDGPU::SReg_512RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 480)) |
    (1u << (AMDGPU::TTMP_512RegClassID - 480)) |
    0,
    // 512-543
    0,
    // 544-575
    0,
    // 576-607
    (1u << (AMDGPU::SReg_1024RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    (1u << (AMDGPU::SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 576)) |
    0,
    // 608-639
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    (1u << (AMDGPU::SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 608)) |
    0,
    // 640-671
    (1u << (AMDGPU::SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    (1u << (AMDGPU::SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID - 640)) |
    0,
};
const uint32_t VCCRegBankCoverageData[] = {
    // 0-31
    (1u << (AMDGPU::SReg_1RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_XEXECRegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_lo16_in_SGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_sub0_and_SReg_1_with_lo16_in_SGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::VReg_1RegClassID - 0)) |
    (1u << (AMDGPU::VS_16RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_Lo128RegClassID - 0)) |
    (1u << (AMDGPU::SReg_LO16RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_and_SReg_1RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_and_SReg_1_XEXECRegClassID - 0)) |
    (1u << (AMDGPU::SGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_and_SReg_1_with_lo16_in_SGPR_LO16RegClassID - 0)) |
    (1u << (AMDGPU::VS_32RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_with_hi16RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_Lo128RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_Lo128_with_hi16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_XEXEC_with_sub0RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_sub0_and_SReg_1_with_lo16_in_TTMP_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_lo16_in_TTMP_LO16RegClassID - 0)) |
    (1u << (AMDGPU::TTMP_LO16RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_and_SReg_1_with_lo16_in_TTMP_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_lo16_in_M0_CLASS_LO16RegClassID - 0)) |
    (1u << (AMDGPU::M0_CLASS_LO16RegClassID - 0)) |
    (1u << (AMDGPU::SReg_1_with_sub0RegClassID - 0)) |
    0,
    // 32-63
    (1u << (AMDGPU::SRegOrLds_32RegClassID - 32)) |
    (1u << (AMDGPU::SReg_32RegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XEXEC_HIRegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XM0RegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XEXECRegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID - 32)) |
    (1u << (AMDGPU::SReg_32_XM0_XEXECRegClassID - 32)) |
    (1u << (AMDGPU::SGPR_32RegClassID - 32)) |
    (1u << (AMDGPU::TTMP_32RegClassID - 32)) |
    (1u << (AMDGPU::SReg_64_XEXECRegClassID - 32)) |
    (1u << (AMDGPU::SReg_64_XEXEC_XNULLRegClassID - 32)) |
    (1u << (AMDGPU::M0_CLASSRegClassID - 32)) |
    (1u << (AMDGPU::SReg_64RegClassID - 32)) |
    0,
    // 64-95
    (1u << (AMDGPU::SGPR_64RegClassID - 64)) |
    (1u << (AMDGPU::CCR_SGPR_64RegClassID - 64)) |
    (1u << (AMDGPU::Gfx_CCR_SGPR_64RegClassID - 64)) |
    (1u << (AMDGPU::TTMP_64RegClassID - 64)) |
    0,
    // 96-127
    0,
    // 128-159
    0,
    // 160-191
    0,
    // 192-223
    0,
    // 224-255
    0,
    // 256-287
    0,
    // 288-319
    0,
    // 320-351
    0,
    // 352-383
    0,
    // 384-415
    0,
    // 416-447
    0,
    // 448-479
    0,
    // 480-511
    0,
    // 512-543
    0,
    // 544-575
    0,
    // 576-607
    0,
    // 608-639
    0,
    // 640-671
    0,
};
const uint32_t VGPRRegBankCoverageData[] = {
    // 0-31
    (1u << (AMDGPU::VS_16RegClassID - 0)) |
    (1u << (AMDGPU::VGPR_16RegClassID - 0)) |
    (1u << (AMDGPU::VS_16_Lo128RegClassID - 0)) |
    (1u << (AMDGPU::VGPR_16_Lo128RegClassID - 0)) |
    (1u << (AMDGPU::AV_32RegClassID - 0)) |
    (1u << (AMDGPU::VS_32RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_with_hi16RegClassID - 0)) |
    (1u << (AMDGPU::VRegOrLds_32RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_Lo128RegClassID - 0)) |
    (1u << (AMDGPU::VS_32_Lo128_with_hi16RegClassID - 0)) |
    0,
    // 32-63
    (1u << (AMDGPU::VGPR_32RegClassID - 32)) |
    (1u << (AMDGPU::VGPR_32_Lo128RegClassID - 32)) |
    (1u << (AMDGPU::VReg_64RegClassID - 32)) |
    (1u << (AMDGPU::AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 32)) |
    (1u << (AMDGPU::VRegOrLds_32_and_VS_32_Lo128RegClassID - 32)) |
    (1u << (AMDGPU::AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 32)) |
    (1u << (AMDGPU::AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 32)) |
    (1u << (AMDGPU::VReg_64_Align2RegClassID - 32)) |
    (1u << (AMDGPU::AV_64RegClassID - 32)) |
    (1u << (AMDGPU::VS_64RegClassID - 32)) |
    (1u << (AMDGPU::VS_64_with_sub0_in_VS_32_Lo128RegClassID - 32)) |
    (1u << (AMDGPU::VS_64_with_sub1_in_VS_32_Lo128RegClassID - 32)) |
    (1u << (AMDGPU::AV_64_Align2RegClassID - 32)) |
    0,
    // 64-95
    (1u << (AMDGPU::VReg_96RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_hi16_in_VGPR_16_Lo128RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_hi16_in_VGPR_16_Lo128_and_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 64)) |
    (1u << (AMDGPU::VReg_96_Align2RegClassID - 64)) |
    (1u << (AMDGPU::VReg_128RegClassID - 64)) |
    (1u << (AMDGPU::AV_96RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_Align2RegClassID - 64)) |
    (1u << (AMDGPU::AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 64)) |
    (1u << (AMDGPU::AV_128RegClassID - 64)) |
    (1u << (AMDGPU::AV_128_Align2RegClassID - 64)) |
    0,
    // 96-127
    (1u << (AMDGPU::AV_128_with_hi16_in_VGPR_16_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_hi16_in_VGPR_16_Lo128_and_AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 96)) |
    (1u << (AMDGPU::VReg_128_Align2RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 96)) |
    (1u << (AMDGPU::VReg_160RegClassID - 96)) |
    (1u << (AMDGPU::AV_160_with_hi16_in_VGPR_16_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 96)) |
    (1u << (AMDGPU::AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 96)) |
    (1u << (AMDGPU::AV_160RegClassID - 96)) |
    (1u << (AMDGPU::AV_160_Align2RegClassID - 96)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 96)) |
    0,
    // 128-159
    (1u << (AMDGPU::AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_hi16_in_VGPR_16_Lo128_and_AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 128)) |
    (1u << (AMDGPU::AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 128)) |
    (1u << (AMDGPU::VReg_160_Align2RegClassID - 128)) |
    (1u << (AMDGPU::VReg_192RegClassID - 128)) |
    (1u << (AMDGPU::AV_192_with_hi16_in_VGPR_16_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 128)) |
    (1u << (AMDGPU::VReg_192_Align2RegClassID - 128)) |
    (1u << (AMDGPU::AV_192RegClassID - 128)) |
    (1u << (AMDGPU::AV_192_Align2RegClassID - 128)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 128)) |
    0,
    // 160-191
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_hi16_in_VGPR_16_Lo128_and_AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 160)) |
    (1u << (AMDGPU::AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 160)) |
    (1u << (AMDGPU::VReg_224RegClassID - 160)) |
    (1u << (AMDGPU::AV_224_with_hi16_in_VGPR_16_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 160)) |
    (1u << (AMDGPU::AV_224RegClassID - 160)) |
    (1u << (AMDGPU::AV_224_Align2RegClassID - 160)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 160)) |
    0,
    // 192-223
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_hi16_in_VGPR_16_Lo128_and_AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 192)) |
    (1u << (AMDGPU::AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 192)) |
    (1u << (AMDGPU::VReg_224_Align2RegClassID - 192)) |
    (1u << (AMDGPU::AV_256RegClassID - 192)) |
    (1u << (AMDGPU::AV_256_Align2RegClassID - 192)) |
    0,
    // 224-255
    (1u << (AMDGPU::VReg_256RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_hi16_in_VGPR_16_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_hi16_in_VGPR_16_Lo128_and_AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 224)) |
    (1u << (AMDGPU::VReg_256_Align2RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 224)) |
    (1u << (AMDGPU::AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 224)) |
    0,
    // 256-287
    (1u << (AMDGPU::VReg_288RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_hi16_in_VGPR_16_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_hi16_in_VGPR_16_Lo128_and_AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 256)) |
    (1u << (AMDGPU::VReg_288_Align2RegClassID - 256)) |
    (1u << (AMDGPU::AV_288RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_Align2RegClassID - 256)) |
    (1u << (AMDGPU::AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 256)) |
    0,
    // 288-319
    (1u << (AMDGPU::AV_288_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::VReg_320RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_hi16_in_VGPR_16_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 288)) |
    (1u << (AMDGPU::VReg_320_Align2RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 288)) |
    (1u << (AMDGPU::AV_320RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_Align2RegClassID - 288)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 288)) |
    0,
    // 320-351
    (1u << (AMDGPU::AV_320_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 320)) |
    (1u << (AMDGPU::AV_320_with_hi16_in_VGPR_16_Lo128_and_AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 320)) |
    (1u << (AMDGPU::VReg_352RegClassID - 320)) |
    (1u << (AMDGPU::AV_352RegClassID - 320)) |
    (1u << (AMDGPU::AV_352_Align2RegClassID - 320)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 320)) |
    0,
    // 352-383
    (1u << (AMDGPU::AV_352_with_hi16_in_VGPR_16_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_hi16_in_VGPR_16_Lo128_and_AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 352)) |
    (1u << (AMDGPU::AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 352)) |
    (1u << (AMDGPU::VReg_352_Align2RegClassID - 352)) |
    0,
    // 384-415
    (1u << (AMDGPU::VReg_384RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_hi16_in_VGPR_16_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 384)) |
    (1u << (AMDGPU::VReg_384_Align2RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 384)) |
    (1u << (AMDGPU::AV_384RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_Align2RegClassID - 384)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 384)) |
    0,
    // 416-447
    (1u << (AMDGPU::AV_384_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 416)) |
    (1u << (AMDGPU::AV_384_with_hi16_in_VGPR_16_Lo128_and_AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 416)) |
    0,
    // 448-479
    (1u << (AMDGPU::VReg_512RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_hi16_in_VGPR_16_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_hi16_in_VGPR_16_Lo128_and_AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 448)) |
    (1u << (AMDGPU::VReg_512_Align2RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 448)) |
    (1u << (AMDGPU::AV_512RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_Align2RegClassID - 448)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 448)) |
    0,
    // 480-511
    (1u << (AMDGPU::AV_512_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    (1u << (AMDGPU::AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 480)) |
    0,
    // 512-543
    (1u << (AMDGPU::VReg_1024RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_hi16_in_VGPR_16_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 512)) |
    (1u << (AMDGPU::VReg_1024_Align2RegClassID - 512)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID - 512)) |
    0,
    // 544-575
    (1u << (AMDGPU::AV_1024_with_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID - 544)) |
    (1u << (AMDGPU::AV_1024_with_hi16_in_VGPR_16_Lo128_and_AV_1024_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID - 544)) |
    0,
    // 576-607
    (1u << (AMDGPU::AV_1024_with_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    (1u << (AMDGPU::AV_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    (1u << (AMDGPU::AV_1024_with_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    (1u << (AMDGPU::AV_1024_with_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    (1u << (AMDGPU::AV_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    (1u << (AMDGPU::AV_1024_with_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    (1u << (AMDGPU::AV_1024_with_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    (1u << (AMDGPU::AV_1024_with_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    (1u << (AMDGPU::AV_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID - 576)) |
    0,
    // 608-639
    0,
    // 640-671
    0,
};

constexpr RegisterBank AGPRRegBank(/* ID */ AMDGPU::AGPRRegBankID, /* Name */ "AGPR", /* CoveredRegClasses */ AGPRRegBankCoverageData, /* NumRegClasses */ 651);
constexpr RegisterBank SGPRRegBank(/* ID */ AMDGPU::SGPRRegBankID, /* Name */ "SGPR", /* CoveredRegClasses */ SGPRRegBankCoverageData, /* NumRegClasses */ 651);
constexpr RegisterBank VCCRegBank(/* ID */ AMDGPU::VCCRegBankID, /* Name */ "VCC", /* CoveredRegClasses */ VCCRegBankCoverageData, /* NumRegClasses */ 651);
constexpr RegisterBank VGPRRegBank(/* ID */ AMDGPU::VGPRRegBankID, /* Name */ "VGPR", /* CoveredRegClasses */ VGPRRegBankCoverageData, /* NumRegClasses */ 651);
} // end namespace AMDGPU

const RegisterBank *AMDGPUGenRegisterBankInfo::RegBanks[] = {
    &AMDGPU::AGPRRegBank,
    &AMDGPU::SGPRRegBank,
    &AMDGPU::VCCRegBank,
    &AMDGPU::VGPRRegBank,
};

const unsigned AMDGPUGenRegisterBankInfo::Sizes[] = {
    // Mode = 0 (Default)
    1024,
    1024,
    64,
    1024,
};

AMDGPUGenRegisterBankInfo::AMDGPUGenRegisterBankInfo(unsigned HwMode)
    : RegisterBankInfo(RegBanks, AMDGPU::NumRegisterBanks, Sizes, HwMode) {
  // Assert that RegBank indices match their ID's
#ifndef NDEBUG
  for (auto RB : enumerate(RegBanks))
    assert(RB.index() == RB.value()->getID() && "Index != ID");
#endif // NDEBUG
}
const RegisterBank &
AMDGPUGenRegisterBankInfo::getRegBankFromRegClass(const TargetRegisterClass &RC, LLT) const {
  constexpr uint32_t InvalidRegBankID = uint32_t(AMDGPU::InvalidRegBankID) & 15;
  static const uint32_t RegClass2RegBank[82] = {
    (uint32_t(InvalidRegBankID) << 0) |
    (uint32_t(InvalidRegBankID) << 4) | // SReg_1RegClassID
    (uint32_t(InvalidRegBankID) << 8) | // SReg_1_XEXECRegClassID
    (uint32_t(InvalidRegBankID) << 12) | // SReg_1_with_lo16_in_SGPR_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // SReg_1_with_sub0RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // SReg_1_XEXEC_with_sub0RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // SReg_1_with_sub0_and_SReg_1_with_lo16_in_SGPR_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 28), // SReg_1_with_lo16_in_TTMP_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // SReg_1_with_sub0_and_SReg_1_with_lo16_in_TTMP_LO16RegClassID
    (uint32_t(AMDGPU::VCCRegBankID) << 4) | // SReg_1_with_lo16_in_M0_CLASS_LO16RegClassID
    (uint32_t(AMDGPU::VCCRegBankID) << 8) | // VReg_1RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // VS_16RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // VGPR_16RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // VS_16_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AGPR_LO16RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // VGPR_16_Lo128RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // SReg_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 4) | // VS_16_and_SReg_1RegClassID
    (uint32_t(InvalidRegBankID) << 8) | // VS_16_and_SReg_1_XEXECRegClassID
    (uint32_t(InvalidRegBankID) << 12) |
    (uint32_t(InvalidRegBankID) << 16) | // SGPR_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // VS_16_and_SReg_1_with_lo16_in_SGPR_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // TTMP_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 28), // VS_16_and_SReg_1_with_lo16_in_TTMP_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // M0_CLASS_LO16RegClassID
    (uint32_t(InvalidRegBankID) << 4) |
    (uint32_t(InvalidRegBankID) << 8) | // AV_32RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // VS_32RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // VS_32_with_hi16RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // VS_32_Lo128RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // VS_32_Lo128_with_hi16RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // VRegOrLds_32RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 0) | // AGPR_32RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // VGPR_32RegClassID
    (uint32_t(InvalidRegBankID) << 8) | // SRegOrLds_32RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // SReg_32RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // SReg_32_XEXEC_HIRegClassID
    (uint32_t(InvalidRegBankID) << 20) | // SReg_32_XM0RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // SReg_32_XEXECRegClassID
    (uint32_t(InvalidRegBankID) << 28), // SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // SReg_32_XM0_XEXECRegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // VRegOrLds_32_and_VS_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // VGPR_32_Lo128RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // SGPR_32RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // TTMP_32RegClassID
    (uint32_t(InvalidRegBankID) << 20) |
    (uint32_t(InvalidRegBankID) << 24) |
    (uint32_t(InvalidRegBankID) << 28), // M0_CLASSRegClassID
    (uint32_t(InvalidRegBankID) << 0) |
    (uint32_t(InvalidRegBankID) << 4) | // AV_64RegClassID
    (uint32_t(InvalidRegBankID) << 8) | // VS_64RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // AV_64_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 16) | // AReg_64RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // VReg_64RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // VS_64_with_sub0_in_VS_32_Lo128RegClassID
    (uint32_t(InvalidRegBankID) << 28), // VS_64_with_sub1_in_VS_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 0) | // AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // SReg_64RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // SReg_64_XEXECRegClassID
    (uint32_t(InvalidRegBankID) << 24) | // SReg_64_XEXEC_XNULLRegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // SGPR_64RegClassID
    (uint32_t(InvalidRegBankID) << 4) | // CCR_SGPR_64RegClassID
    (uint32_t(InvalidRegBankID) << 8) | // Gfx_CCR_SGPR_64RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // TTMP_64RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // AV_96RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 20) | // AReg_96RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // AV_96_Align2RegClassID
    (uint32_t(InvalidRegBankID) << 28), // AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // VReg_96RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_96_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 8) | // AReg_96_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 12) | // AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_96_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // VReg_96_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_96_with_hi16_in_VGPR_16_Lo128_and_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_96_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_96RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SReg_96_with_sub0_sub1RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_96RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_96_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_96_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // TTMP_96RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // TTMP_96_with_sub0_sub1RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SReg_96_with_sub1_sub2RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // AV_128RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // AV_128_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AReg_128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // VReg_128RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_128_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 8) | // AReg_128_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_128_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // VReg_128_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 20) | // AReg_128_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_128_with_hi16_in_VGPR_16_Lo128_and_AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_128_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_128_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_128_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SReg_128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SReg_128_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_128_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_128_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // TTMP_128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // TTMP_128_with_sub0_sub1_sub2RegClassID
    (uint32_t(InvalidRegBankID) << 24) |
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SReg_128_with_sub1_sub2_sub3RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // AV_160RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 4) | // AReg_160RegClassID
    (uint32_t(InvalidRegBankID) << 8) | // AV_160_Align2RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // VReg_160RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_160_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_160_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 28), // AReg_160_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 0) | // AReg_160_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // VReg_160_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_160_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_160_with_hi16_in_VGPR_16_Lo128_and_AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_160_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_160_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_160_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_160_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_160RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SReg_160_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_160RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_160_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_160_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_160_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // TTMP_160RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SReg_160_with_sub1_sub2_sub3RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_160_with_sub2_sub3_sub4RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // TTMP_160_with_sub0_sub1_sub2RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // AV_192RegClassID
    (uint32_t(InvalidRegBankID) << 28), // AV_192_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 0) | // AReg_192RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // VReg_192RegClassID
    (uint32_t(InvalidRegBankID) << 8) | // AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_192_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_192_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 20) | // AReg_192_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // VReg_192_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 0) | // AReg_192_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_192_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_192_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_192_with_hi16_in_VGPR_16_Lo128_and_AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_192_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_192_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_192_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_192_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_192_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_192RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SReg_192_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_192RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_192_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_192_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_192_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_192_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // TTMP_192RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SReg_192_with_sub1_sub2_sub3RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SReg_192_with_sub2_sub3_sub4RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SReg_192_with_sub3_sub4_sub5RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // AV_224RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 4) | // AReg_224RegClassID
    (uint32_t(InvalidRegBankID) << 8) | // AV_224_Align2RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // VReg_224RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_224_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_224_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 0) | // AReg_224_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 4) | // AReg_224_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_224_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // VReg_224_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_224_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_224_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_224_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_224_with_hi16_in_VGPR_16_Lo128_and_AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_224_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_224_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_224_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_224_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_224_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_224_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_224_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SReg_224RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SReg_224_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SReg_224_with_sub4_sub5_sub6RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_224RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_224_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_224_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_224_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_224_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_224_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_224_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // TTMP_224RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SReg_224_with_sub1_sub2_sub3RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SReg_224_with_sub2_sub3_sub4RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_224_with_sub3_sub4_sub5RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // AV_256RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // AV_256_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 28), // AReg_256RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // VReg_256RegClassID
    (uint32_t(InvalidRegBankID) << 4) | // AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_256_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_256_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 20) | // AReg_256_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_256_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // VReg_256_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 0) | // AReg_256_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_256_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_256_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_256_with_hi16_in_VGPR_16_Lo128_and_AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_256_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_256_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_256_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_256_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_256_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_256_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SReg_256RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SReg_256_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SReg_256_with_sub4_sub5_sub6RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_256RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_256_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_256_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_256_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_256_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_256_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_256_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // TTMP_256RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SReg_256_with_sub1_sub2_sub3RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SReg_256_with_sub2_sub3_sub4RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_256_with_sub3_sub4_sub5RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // AV_288RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AReg_288RegClassID
    (uint32_t(InvalidRegBankID) << 28), // AV_288_Align2RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // VReg_288RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_288_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_288_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_288_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AReg_288_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 28), // AReg_288_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_288_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // VReg_288_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_288_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_288_with_hi16_in_VGPR_16_Lo128_and_AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_288_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_288_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_288_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_288_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_288_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_288_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SReg_288RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SReg_288_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_288RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_288_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_288_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_288_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_288_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_288_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_288_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_288_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // TTMP_288RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SReg_288_with_sub2_sub3_sub4RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_288_with_sub3_sub4_sub5RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // AV_320RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // AV_320_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 28), // AReg_320RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // VReg_320RegClassID
    (uint32_t(InvalidRegBankID) << 4) | // AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_320_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_320_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_320_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AReg_320_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_320_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // VReg_320_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 4) | // AReg_320_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_320_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_320_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_320_with_hi16_in_VGPR_16_Lo128_and_AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_320_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_320_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_320_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_320_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_320_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_320_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_320_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SReg_320RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_320_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_320RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_320_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_320_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_320_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_320_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_320_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_320_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_320_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // TTMP_320RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SReg_320_with_sub2_sub3_sub4RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SReg_320_with_sub3_sub4_sub5RegClassID
    (uint32_t(InvalidRegBankID) << 12) | // AV_352RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 16) | // AReg_352RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // AV_352_Align2RegClassID
    (uint32_t(InvalidRegBankID) << 24) | // AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // VReg_352RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_352_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_352_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_352_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_352_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 20) | // AReg_352_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AReg_352_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // VReg_352_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_352_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_352_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_352_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_352_with_hi16_in_VGPR_16_Lo128_and_AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_352_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_352_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_352_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_352_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_352_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_352_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_352_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_352_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SReg_352RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SReg_352_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SReg_352_with_sub8_sub9_sub10RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_352RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_352_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_352_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_352_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_352_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_352_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_352_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_352_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_352_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_352_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_352_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // TTMP_352RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_352_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_352_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SReg_352_with_sub2_sub3_sub4RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SReg_352_with_sub3_sub4_sub5RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // AV_384RegClassID
    (uint32_t(InvalidRegBankID) << 20) | // AV_384_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AReg_384RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // VReg_384RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_384_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_384_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_384_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_384_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AReg_384_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // VReg_384_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 4) | // AReg_384_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_384_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_384_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_384_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_384_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_384_with_hi16_in_VGPR_16_Lo128_and_AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_384_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_384_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_384_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_384_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_384_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_384_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_384_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_384_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_384_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SReg_384RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SReg_384_with_sub0_sub1_sub2RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SReg_384_with_sub8_sub9_sub10RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_384RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_384_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_384_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_384_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_384_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_384_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_384_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_384_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // TTMP_384RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_384_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_384_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SReg_384_with_sub2_sub3_sub4RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SReg_384_with_sub3_sub4_sub5RegClassID
    (uint32_t(InvalidRegBankID) << 0) | // AV_512RegClassID
    (uint32_t(InvalidRegBankID) << 4) | // AV_512_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 8) | // AReg_512RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // VReg_512RegClassID
    (uint32_t(InvalidRegBankID) << 16) | // AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_512_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_512_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_512_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_512_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 16) | // AReg_512_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // VReg_512_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 28), // AReg_512_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_512_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_512_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_512_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_512_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_512_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_512_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_512_with_hi16_in_VGPR_16_Lo128_and_AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_512_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_512_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_512_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_512_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_512_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_512_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_512_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_512_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_512_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_512_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_512_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SReg_512RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_512RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_512_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_512_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_512_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_512_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_512_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_512_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_512_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // TTMP_512RegClassID
    (uint32_t(InvalidRegBankID) << 28),
    (uint32_t(InvalidRegBankID) << 0) |
    (uint32_t(AMDGPU::AGPRRegBankID) << 4) | // AReg_1024RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // VReg_1024RegClassID
    (uint32_t(InvalidRegBankID) << 12) |
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_1024_with_sub0_sub1_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_1024_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 12) | // AReg_1024_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // VReg_1024_Align2RegClassID
    (uint32_t(AMDGPU::AGPRRegBankID) << 24) | // AReg_1024_with_sub0_sub1_sub2_in_AReg_96_with_sub1_sub2_in_AReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_VReg_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_1024_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_1024_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_1024_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_1024_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_1024_with_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_1024_with_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_1024_with_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_1024_with_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_hi16_in_VGPR_16_Lo128_and_AV_1024_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_1024_with_sub0_sub1_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_1024_with_sub0_sub1_sub2_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_1024_with_sub0_sub1_sub2_in_AV_96_with_sub1_sub2_in_AV_64_Align2_and_AV_64_with_hi16_in_VGPR_16_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_sub0_sub1_sub2_sub3_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub1_sub2_sub3_sub4_sub5_sub6_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_1024_with_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_1024_with_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_1024_with_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_1024_with_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_1024_with_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 4) | // AV_1024_with_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 8) | // AV_1024_with_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 12) | // AV_1024_with_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 16) | // AV_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 20) | // AV_1024_with_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 24) | // AV_1024_with_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 28), // AV_1024_with_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::VGPRRegBankID) << 0) | // AV_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_AV_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_AV_256_with_sub2_sub3_sub4_sub5_sub6_sub7_in_AV_192_with_sub1_sub2_sub3_sub4_sub5_in_AV_160_with_sub1_sub2_sub3_sub4_in_AV_128_with_sub1_sub2_sub3_in_AV_96_Align2_and_AV_96_with_sub1_sub2_in_AV_64_with_sub1_in_VGPR_32_Lo128RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SReg_1024RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_1024_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_1024_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_1024_with_sub0_sub1_sub2_sub3_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_1024_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 12) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub0_sub1_sub2_sub3_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 16) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 20) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 24) | // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_sub5_sub6_sub7_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 28), // SGPR_1024_with_sub0_sub1_in_CCR_SGPR_64_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_in_SGPR_512_with_sub0_sub1_in_CCR_SGPR_64_with_sub4_lo16_sub4_hi16_sub5_lo16_sub5_hi16_sub6_lo16_sub6_hi16_sub7_lo16_sub7_hi16_sub8_lo16_sub8_hi16_sub9_lo16_sub9_hi16_sub10_lo16_sub10_hi16_sub11_lo16_sub11_hi16_sub12_lo16_sub12_hi16_sub13_lo16_sub13_hi16_in_SGPR_320_with_sub0_sub1_in_CCR_SGPR_64_and_SGPR_320_with_sub4_sub5_sub6_sub7_sub8_sub9_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 0) | // SGPR_1024_with_sub0_sub1_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 4) | // SGPR_1024_with_sub0_sub1_sub2_sub3_sub4_sub5_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64_and_SGPR_1024_with_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_sub28_sub29_sub30_sub31_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_in_SGPR_192_with_sub4_sub5_in_Gfx_CCR_SGPR_64RegClassID
    (uint32_t(AMDGPU::SGPRRegBankID) << 8) // SGPR_1024_with_sub12_sub13_sub14_sub15_sub16_sub17_sub18_sub19_sub20_sub21_sub22_sub23_sub24_sub25_sub26_sub27_in_SGPR_512_with_sub8_sub9_sub10_sub11_sub12_sub13_sub14_sub15_in_SGPR_256_with_sub4_sub5_sub6_sub7_in_SGPR_128_with_sub2_sub3_in_CCR_SGPR_64RegClassID
  };
  const unsigned RegClassID = RC.getID();
  if (LLVM_LIKELY(RegClassID < 651)) {
    unsigned RegBankID = (RegClass2RegBank[RegClassID / 8] >> ((RegClassID % 8) * 4)) & 15;
    if (RegBankID != InvalidRegBankID)
      return getRegBank(RegBankID);
  }
  llvm_unreachable(llvm::Twine("Target needs to handle register class ID 0x").concat(llvm::Twine::utohexstr(RegClassID)).str().c_str());
}
} // end namespace llvm
#endif // GET_TARGET_REGBANK_IMPL
